From cd1f0c1520264a4f840b1cf57d6701d562850bb6 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Sun, 28 Jun 2020 03:38:15 +0300
Subject: [PATCH 21/59] AlpineApkAuthHelper: implement all operations in async
 mode

also delete useless test() action
---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp  | 234 ++++++++++++------
 .../AlpineApkBackend/AlpineApkAuthHelper.h    |  19 +-
 .../org.kde.discover.alpineapkbackend.actions |   6 -
 3 files changed, 181 insertions(+), 78 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index 0496c8f28..a3236011f 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -40,88 +40,194 @@ using namespace KAuth;
 
 AlpineApkAuthHelper::AlpineApkAuthHelper() {}
 
-ActionReply AlpineApkAuthHelper::test(const QVariantMap &args)
+bool AlpineApkAuthHelper::openDatabase(const QVariantMap &args, bool readwrite)
 {
-    const QString txt = args[QStringLiteral("txt")].toString();
-
-    ActionReply reply = ActionReply::HelperErrorReply();
-    QByteArray replyData(QByteArrayLiteral("ok"));
+    // maybe set fakeRoot (needs to be done before Database::open()
+    const QString fakeRoot = args.value(QLatin1String("fakeRoot"), QString()).toString();
+    if (!fakeRoot.isEmpty()) {
+        m_apkdb.setFakeRoot(fakeRoot);
+    }
 
-    // write some text file at the root directory as root, why not
-    QFile f(QStringLiteral("/lol.txt"));
-    if (f.open(QIODevice::ReadWrite | QIODevice::Text)) {
-        f.write(txt.toUtf8());
-        f.close();
+    // calculate flags to use during open
+    QtApk::DbOpenFlags fl = QtApk::QTAPK_OPENF_ENABLE_PROGRESSFD;
+    if (readwrite) {
+        fl |= QtApk::QTAPK_OPENF_READWRITE;
+    }
 
-        reply = ActionReply::SuccessReply();
-        reply.setData({
-            { QStringLiteral("reply"), replyData },
-        });
+    if (!m_apkdb.open(fl)) {
+        return false;
     }
+    return true;
+}
 
-    return reply;
+void AlpineApkAuthHelper::closeDatabase()
+{
+    m_apkdb.close();
 }
 
-ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
+void AlpineApkAuthHelper::setupTransactionPostCreate(QtApk::Transaction *trans)
 {
-    ActionReply reply = ActionReply::HelperErrorReply();
+    // receive progress notifications
+    QObject::connect(trans, &QtApk::Transaction::progressChanged,
+                     this, &AlpineApkAuthHelper::reportProgress);
 
-    const QString fakeRoot = args.value(QLatin1String("fakeRoot"), QString()).toString();
-    if (!fakeRoot.isEmpty()) {
-        m_apkdb.setFakeRoot(fakeRoot);
-    }
+    // receive error messages
+    QObject::connect(trans, &QtApk::Transaction::errorOccured,
+                     this, &AlpineApkAuthHelper::onTransactionError);
 
-    HelperSupport::progressStep(10);
+    // what to do when transaction is complete
+    QObject::connect(trans, &QtApk::Transaction::finished,
+                     this, &AlpineApkAuthHelper::onTransactionFinished);
+}
 
-    if (!m_apkdb.open(QtApk::QTAPK_OPENF_READWRITE)) {
-        reply.setErrorDescription(QStringLiteral("Failed to open database!"));
-        return reply;
+void AlpineApkAuthHelper::reportProgress(float percent)
+{
+    int p = static_cast<int>(percent);
+    if (p < 0) p = 0;
+    if (p > 100) p = 100;
+    HelperSupport::progressStep(p);
+}
+
+void AlpineApkAuthHelper::onTransactionError(const QString &msg)
+{
+    qCWarning(LOG_AUTHHELPER).nospace() << "ERROR occured in transaction \""
+                                        << m_currentTransaction->desc()
+                                        << "\": " << msg;
+    const QString errMsg = m_currentTransaction->desc() + QLatin1String(" failed: ") + msg;
+    m_actionReply.setErrorDescription(errMsg);
+    m_actionReply.setData({
+        { QLatin1String("errorString"), errMsg }
+    });
+    m_trans_ok = false;
+}
+
+void AlpineApkAuthHelper::onTransactionFinished()
+{
+    m_lastChangeset = m_currentTransaction->changeset();
+    m_currentTransaction->deleteLater();
+    m_currentTransaction = nullptr;
+    m_loop.quit();
+}
+
+ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
+{
+    // return error by default
+    m_actionReply = ActionReply::HelperErrorReply();
+
+    HelperSupport::progressStep(0);
+
+    if (!openDatabase(args)) {
+        m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
+        return m_actionReply;
     }
 
-    bool update_ok = m_apkdb.updatePackageIndex();
+    m_trans_ok = true;
+    QtApk::Transaction *trans = m_apkdb.updatePackageIndex();
+    setupTransactionPostCreate(trans);
 
-    if (update_ok) {
+    trans->start();
+    m_loop.exec();
+
+    if (m_trans_ok) {
         int updatesCount = m_apkdb.upgradeablePackagesCount();
-        reply = ActionReply::SuccessReply();
-        reply.setData({
+        m_actionReply = ActionReply::SuccessReply();
+        m_actionReply.setData({
             { QLatin1String("updatesCount"), updatesCount }
         });
-    } else {
-        reply.setErrorDescription(QStringLiteral("Repo update failed!"));
-        reply.setData({
-            { QLatin1String("errorString"), QStringLiteral("Repo update failed!") }
-        });
     }
 
-    m_apkdb.close();
+    closeDatabase();
     HelperSupport::progressStep(100);
 
-    return reply;
+    return m_actionReply;
 }
 
 ActionReply AlpineApkAuthHelper::add(const QVariantMap &args)
 {
-    Q_UNUSED(args)
-    ActionReply reply = ActionReply::HelperErrorReply();
-    return reply;
+    // return error by default
+    m_actionReply = ActionReply::HelperErrorReply();
+
+    HelperSupport::progressStep(0);
+
+    if (!openDatabase(args)) {
+        m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
+        return m_actionReply;
+    }
+
+    const QString pkgName = args.value(QLatin1String("pkgName"), QString()).toString();
+    if (pkgName.isEmpty()) {
+        m_actionReply.setErrorDescription(QStringLiteral("Specify pkgName for adding!"));
+        return m_actionReply;
+    }
+
+    m_trans_ok = true;
+    QtApk::Transaction *trans = m_apkdb.add(pkgName);
+    setupTransactionPostCreate(trans);
+
+    trans->start();
+    m_loop.exec();
+
+    if (m_trans_ok) {
+        m_actionReply = ActionReply::SuccessReply();
+    }
+
+    closeDatabase();
+    HelperSupport::progressStep(100);
+
+    return m_actionReply;
 }
 
 ActionReply AlpineApkAuthHelper::del(const QVariantMap &args)
 {
-    Q_UNUSED(args)
-    ActionReply reply = ActionReply::HelperErrorReply();
-    return reply;
+    // return error by default
+    m_actionReply = ActionReply::HelperErrorReply();
+
+    HelperSupport::progressStep(0);
+
+    if (!openDatabase(args)) {
+        m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
+        return m_actionReply;
+    }
+
+    const QString pkgName = args.value(QLatin1String("pkgName"), QString()).toString();
+    if (pkgName.isEmpty()) {
+        m_actionReply.setErrorDescription(QStringLiteral("Specify pkgName for removing!"));
+        return m_actionReply;
+    }
+
+    const bool delRdepends = args.value(QLatin1String("delRdepends"), false).toBool();
+
+    QtApk::DbDelFlags delFlags = QtApk::QTAPK_DEL_DEFAULT;
+    if (delRdepends) {
+        delFlags = QtApk::QTAPK_DEL_RDEPENDS;
+    }
+
+    m_trans_ok = true;
+    QtApk::Transaction *trans = m_apkdb.del(pkgName, delFlags);
+    setupTransactionPostCreate(trans);
+
+    trans->start();
+    m_loop.exec();
+
+    if (m_trans_ok) {
+        m_actionReply = ActionReply::SuccessReply();
+    }
+
+    closeDatabase();
+    HelperSupport::progressStep(100);
+
+    return m_actionReply;
 }
 
 ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
 {
-    ActionReply reply = ActionReply::HelperErrorReply();
+    m_actionReply = ActionReply::HelperErrorReply();
 
-    HelperSupport::progressStep(10);
+    HelperSupport::progressStep(0);
 
-    if (!m_apkdb.open(QtApk::QTAPK_OPENF_READWRITE)) {
-        reply.setErrorDescription(QStringLiteral("Failed to open database!"));
-        return reply;
+    if (!openDatabase(args)) {
+        m_actionReply.setErrorDescription(QStringLiteral("Failed to open database!"));
+        return m_actionReply;
     }
 
     bool onlySimulate = args.value(QLatin1String("onlySimulate"), false).toBool();
@@ -131,28 +237,18 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
         qCDebug(LOG_AUTHHELPER) << "Simulating upgrade run.";
     }
 
-    const QString fakeRoot = args.value(QLatin1String("fakeRoot"), QString()).toString();
-    if (!fakeRoot.isEmpty()) {
-        m_apkdb.setFakeRoot(fakeRoot);
-    }
-
-    // no progress notifications for now
-    //int progress_fd = m_apkdb.progressFd();
-    //qCDebug(LOG_AUTHHELPER) << "    progress_fd: " << progress_fd;
+    m_trans_ok = true;
 
-    //QScopedPointer<QSocketNotifier> notifier(new QSocketNotifier(progress_fd, QSocketNotifier::Read));
-    //QObject::connect(notifier.data(), &QSocketNotifier::activated, notifier.data(), [](int sock) {
-    //    Q_UNUSED(sock)
-    //    qCDebug(LOG_AUTHHELPER) << "        read trigger from progress_fd!";
-    //});
+    QtApk::Transaction *trans = m_apkdb.upgrade(flags);
+    setupTransactionPostCreate(trans);
 
-    QtApk::Changeset changes;
-    bool upgrade_ok = m_apkdb.upgrade(flags, &changes);
+    trans->start();
+    m_loop.exec();
 
-    if (upgrade_ok) {
-        reply = ActionReply::SuccessReply();
+    if (m_trans_ok) {
+        m_actionReply = ActionReply::SuccessReply();
         QVariantMap replyData;
-        const QVector<QtApk::ChangesetItem> ch = changes.changes();
+        const QVector<QtApk::ChangesetItem> ch = m_lastChangeset.changes();
         QVector<QVariant> chVector;
         QVector<QtApk::Package> pkgVector;
         for (const QtApk::ChangesetItem &it: ch) {
@@ -160,15 +256,13 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
         }
         replyData.insert(QLatin1String("changes"), QVariant::fromValue(pkgVector));
         replyData.insert(QLatin1String("onlySimulate"), onlySimulate);
-        reply.setData(replyData);
-    } else {
-        reply.setErrorDescription(QStringLiteral("Repo upgrade failed!"));
+        m_actionReply.setData(replyData);
     }
 
-    m_apkdb.close();
+    closeDatabase();
     HelperSupport::progressStep(100);
 
-    return reply;
+    return m_actionReply;
 }
 
 KAUTH_HELPER_MAIN("org.kde.discover.alpineapkbackend", AlpineApkAuthHelper)
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index a634ce233..a670a2aa1 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -18,6 +18,7 @@
  *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
  ***************************************************************************/
 
+#include <QEventLoop>
 #include <QObject>
 #include <QVariant>
 #include <KAuthActionReply>
@@ -33,12 +34,26 @@ public:
     AlpineApkAuthHelper();
 
 public Q_SLOTS:
-    ActionReply test(const QVariantMap &args);
     ActionReply update(const QVariantMap &args);
     ActionReply add(const QVariantMap &args);
     ActionReply del(const QVariantMap &args);
     ActionReply upgrade(const QVariantMap &args);
 
+protected:
+    bool openDatabase(const QVariantMap &args, bool readwrite = true);
+    void closeDatabase();
+    void setupTransactionPostCreate(QtApk::Transaction *trans);
+
+protected Q_SLOTS:
+    void reportProgress(float percent);
+    void onTransactionError(const QString &msg);
+    void onTransactionFinished();
+
 private:
-    QtApk::Database m_apkdb;
+    QtApk::DatabaseAsync m_apkdb; // runs transactions in bg thread
+    QtApk::Transaction *m_currentTransaction = nullptr;
+    QEventLoop m_loop; // event loop that will run and wait while bg transaction is in progress
+    ActionReply m_actionReply; // return value for main action slots
+    bool m_trans_ok = true; // flag to indicate if bg transaction was successful
+    QtApk::Changeset m_lastChangeset; // changeset from last completed transaction
 };
diff --git a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
index 10305a1af..0755c4157 100644
--- a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
+++ b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
@@ -1,9 +1,3 @@
-[org.kde.discover.alpineapkbackend.test]
-Name=Test Action
-Description=Just test
-Policy=auth_admin
-Persistence=session
-
 [org.kde.discover.alpineapkbackend.update]
 Name=Update repository index
 Description=Updates available packages list from repositories
-- 
GitLab


